#!/usr/bin/env ruby

require 'pstore'
require 'cgi'
require 'util'

rdb = PStore.new('r.db')

q = CGI.new

rdb.transaction do
  if !rdb.root?('r')
    rdb['r'] = []
  end
end

def html_header
  return if $H
  puts "Content-Type: text/html; charset=UTF-8\n\n"
  puts %Q(<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ja">
<head>
 <meta http-equiv="CONTENT-TYPE" content="text/html; charset=UTF-8">
 <title>なんでもランキング</title>
 <link rev="MADE" href="mailto:shinichiro.hamaji _at_ gmail.com">
 <link rel="INDEX" href=".">
 <link rel="stylesheet" type="text/css" href="/site.css">
 <script type="text/javascript" charset="UTF-8" src="r.js"></script>
</head>
<body>)
  $H=true
end

begin
  r = q['q'].to_s
  if r != ''
    dbname = "db/#{CGI.escape(r)}.db"
    db = PStore.new(dbname)
    if !File.exist?(dbname)
      rdb.transaction do
        rdb['r'] << r
      end
      db.transaction do
        db['l'] = []
      end
    end

    html_header
    puts %Q(<h1>なんでもランキング - #{r}</h1><ol id="l">)
    er = CGI.escape(r)
    put_list(db, er)
    puts "</ol>"
    puts %Q(<form method="GET">
項目名: <input name="v" size="40">
<input type="submit" onclick="add(this.form, '#{er}'); return false;" value="追加">
</form>)
    puts %Q(<div id="err"></div>)
    puts '</body></html>'
  else
    html_header
    rdb.transaction(true) do
      puts "<h1>なんでもランキング</h1><ul>"
      rdb['r'].each do |r|
        puts %Q(<li><a href="?q=#{r}">#{r}</a>)
      end
      puts "</ul>"
      puts %Q(<form method="GET">ランキング名: <input size="40" name="q"><input type="submit" value="新しいの作る"></form>)
    end
    puts '</body></html>'
  end
rescue
  html_header
  puts "#{$!}<pre>#{$!.backtrace}</pre>"
end
