#!/usr/bin/env ruby

require 'pstore'
require 'cgi'
require 'util'

rdb = PStore.new('r.db')

q = CGI.new

def html_header
  return if $H
  puts "Content-Type: text/html; charset=UTF-8\n\n"
  $H=true
end

begin
  r = q['q'].to_s
  er = CGI.escape(r)
  dbname = "db/#{CGI.escape(r)}.db"
  db = PStore.new(dbname)

  if q['add'].to_s != ''
    l = q['add'].to_s
    db.transaction do
      raise 'already exists' if db['l'].index(l)
      db['l'] << l
    end
    html_header
    put_list(db, er)

  elsif q['del'].to_s != ''
    l = q['del'].to_s
    db.transaction do
      db['l'].delete(l)
    end
    html_header
    put_list(db, er)

  elsif q['up'].to_s != ''
    l = q['up'].to_s
    db.transaction do
      i = db['l'].index(l)
      raise 'not existed' if !i
      if i > 0
        db['l'].delete_at(i)
        db['l'].insert(i-1, l)
      end
    end
    html_header
    put_list(db, er)

  elsif q['down'].to_s != ''
    l = q['down'].to_s
    db.transaction do
      i = db['l'].index(l)
      raise 'not existed' if !i
      if i < db['l'].size-1
        db['l'].delete_at(i)
        db['l'].insert(i+1, l)
      end
    end
    html_header
    put_list(db, er)

  else
    raise 'invalid query'
  end
rescue
  html_header
  puts "#{$!}<pre>#{$!.backtrace}</pre>"
end
